@Echo off
SetLocal

REM PEM or DER encoded Certificate and Key files
Set "SERVER_CERT=%~dp0\custom-server.crt"
Set "SERVER_PKEY=%~dp0\custom-server.key"
Set "SERVER_CA=%~dp0\custom-server-ca-chain.crt"

REM Install Path
Set "INSTALL_PATH=%ProgramFiles(x86)%\Trend Micro\Endpoint Application Control"

REM Specify paths & include keytool and openssl in %PATH%
Set "DEPLOY_PATH=%INSTALL_PATH%\SSLCerts\WebServerCert"
Set "STORE_PATH=%DEPLOY_PATH%\WebServer_Cert.p12"
Set "PATH=%PATH%;%INSTALL_PATH%\AcServer\Java\bin;%INSTALL_PATH%\SSLCerts\bin"

REM Changing the certificate
Echo.
Echo -- Applying new Certificates to Endpoint Application Control Apache Tomcat
Echo  - Certificate             : "%SERVER_CERT%"
Echo  - Certificate Private Key : "%SERVER_PKEY%"
Echo  - Certificate CA Chain    : "%SERVER_CA%"


Echo.
Echo -- Stopping Endpoint Application Control
net stop TMACServerService

REM Creating a temp keystore & verify inputs
Echo.
Echo -- Creating new certiciate store from "%SERVER_CERT%" (including private key and CA chain).
openssl pkcs12 -export ^
    -in "%SERVER_CERT%" ^
    -inkey "%SERVER_PKEY%" ^
    -passout pass:changeit ^
    -out "%~dp0\.temp-custom-server.p12" -name WebServerCert

If ErrorLevel 1 (
    Echo Failed reading "%SERVER_CERT%" or "%SERVER_PKEY%"
    Goto:END
)

REM Replacing the existing keystore
Echo.
Echo -- Replacing existing certificate store "%STORE_PATH%".
If Not Exist "%STORE_PATH%.backup" Copy "%STORE_PATH%" "%STORE_PATH%.backup"
Del "%STORE_PATH%"

keytool -importkeystore ^
    -srcstoretype PKCS12 -srcstorepass changeit -srckeystore "%~dp0\.temp-custom-server.p12" ^
    -deststorepass changeit -destkeypass changeit -deststoretype PKCS12 -destkeystore "%STORE_PATH%"

keytool -import -alias root ^
    -storepass changeit -storetype PKCS12 -keystore "%STORE_PATH%" ^
    -trustcacerts ^
    -file "%SERVER_CA%"

:END
Pause

REM Cleanup
Del "%~dp0\.temp-custom-server.p12" /A H >NUL 2>NUL

Echo.
Echo -- Starting Endpoint Application Control
net start TMACServerService

EndLocal
